/*
 *
 *	Fichier entete global pour l'assembleur.
 *	Dfinit les types, units lexicales, etc...
 *
 * 	Auteur : FAVARD Laurent
 *	Fichier: ASSEMBLE.H
 *	Pays   : FRANCE
 *	Date   : 20 Mars 1994
 *	Revision: 20 Mars 1994
 *	Version : 1.0
 *	Machine : ATARI Falcon030 TOS 4.2
 *	Processeur cible: MC68705 P3S (Famille 6805)
 */

#ifndef __ASSEMBLE__
#define __ASSEMBLE__ __ASSEMBLE__


/*
  ---------------------- Dfinitions diverses ----------------------------
*/

#define TRUE		1
#define FALSE		0

#define TAILLE16	4	/* mot 16 bits = 4 digits */
#define TAILLEID	25	/* len(Identificateur) = 25 caracteres */
#define TAILLETBLSYMBOLE 2048

#define STARTCODEDEFAULT 0x80	/* dbut programme user */

/*
  ------------ Dfinition des units lexicales reconnues ------------------
*/

#define RIEN		0	/* rien du tout */
#define ID		1	/* Identificateurs */
#define NB		2	/* Nombre */
#define FDL		3	/* Fin De Ligne */
#define FDF		4	/* Fin De Fichier */
#define INST		5	/* instruction processeur 68705 */
#define LEXERREUR	6	/* Erreur d'analyse lexicale */
#define VIRG		7
#define DIESE		8
#define PRCENT		9
#define DOLLAR		10
#define UNSCORE		11
#define	DBP		12
#define EQU		20	/* Directive */
#define	ORG		21	/* Directive */
#define END		22	/* Directive */
#define DCB		23	/* Directive */
#define DSB		24
#define TEXT		25	/* Directive */
#define DATA		26	/* Directive */

/*
  --------------------- Dfinitions des types ----------------------------
*/

/* Contient la valeur lexicale d'une unit lexicale: Soit un lexeme texte
   pour un ID,INST,..., soit une valeur numrique pour un NB.
*/
typedef struct {
		 int  numerique;
		 char lexeme[TAILLEID];
	       } Type_ValLex;

extern FILE *fichier;			/* Fichier d'entre du texte source */
extern FILE *FileLST;			/* source+assembl */
extern char *TamponPRG;
extern int  TailleTamponPRG;
extern int  ListingScreen;

#endif