/*
 *
 *	Spcification du module de gestion d'erreurs.
 *
 * 	Auteur : FAVARD Laurent
 *	Fichier: ERREUR.H
 *	Pays   : FRANCE
 *	Date   : 20 Mars 1994
 *	Revision: 3 Avril 1994
 *	Version : 1.0
 *	Release : 1.4
 *	Machine : ATARI Falcon030 TOS 4.2
 *	Processeur cible: MC68705 P3S (Famille 6805)
 */

#ifndef __ERREUR__
#define __ERREUR__ __ERREUR__

/*
  ------------------------ Erreurs lexicales ------------------------------------
*/

#define ERR_ID		0		/* ID trop long ou mal crit */	
#define ERR_UNKNOW	1		/* Terminal inconnu */
#define ERR_DEC		2		/* Valeur dcimale trop large */
#define ERR_HEX		3		/* Valeur hex. trop large ou mal crite */ 
#define ERR_BIN		4		/* Valeur bin. trop large ou mal crite */
#define ERR_REDEFIF	5		/* ID dj dfini */

/*
  ----------------------- Erreurs Smantiques ------------------------------------
*/
	
#define	ERR_DEFINE	0		/* ID dj dfini */
#define ERR_NODEFINE	1		/* ID non dfini  */
#define ERR_INHERANT	2		/* Inhrant interdit */
#define ERR_IMMEDIAT	3		/* Immdiat interdit */
#define ERR_RELATIF	4		/* Relatif interdit */
#define ERR_DIRECT	5		/* Direct interdit */
#define ERR_ETENDU	6		/* etendu interdit */
#define ERR_INDEX	7		/* index interdit */
#define ERR_INDEX0	8		/* Index nul interdit */
#define ERR_INDEX8	9		/* Index 8 bits interdit */
#define ERR_INDEX16	10		/* Index 16 bits interdit */
#define ERR_REGX	11		/* mauvaise ref. reg. index */
#define ERR_BTB		12		/* Bit Test And Branch interdit */
#define ERR_DATASUP8	13		/* Oprande > 8 bits */
#define ERR_OFFSET	14		/* @ relative out of range */
#define	ERR_CPTASM	15		/* dpassement du compt. asm. */
#define ERR_BIT		16		/* bit spcifi non [0,7] */

/*
  --------------- Primitives d'erreurs aux trois niveaux -------------------------
*/

extern void LEXerreur(int no_erreur);
extern void SYNerreur(void);
extern void SEMerreur(int no_erreur,long ligne,char *information);

#endif
