/*
 * ----------------------------------------------------------------------------------------------
 *
 *	Entete des primitives de gestion de gnrations de codes machines.
 *
 * 	Auteur 	: 	FAVARD Laurent
 *	Fichier	: 	CODEUR.H
 *	Pays   	: 	FRANCE
 *	Date   	: 	20 Mars 1994
 *	Revision: 	30 Avril 1997
 *	Version : 	2.0
 *	Release : 	2.1
 *	Machine : 	ATARI Falcon030 TOS 4.2
 *
 * ----------------------------------------------------------------------------------------------
 */

#ifndef __CODEUR__
#define __CODEUR__ __CODEUR__

/*
 *
 */
 
/* Initialise le pointeur sur la table des ocpcodes du processeur cible */
extern	int InitTableAsm(char	*Processeur);

/*	Return TRUE si le lexeme pass est une instruction du processeur */
extern	int EstInst(char *lexeme);

/*
 *
 */

extern	int AvancerCompteur(unsigned long addition);
extern	int InitCompteur(unsigned long valeur);

/*
  ----------------- Primitives de calcul des codes machines -------------------
*/

/* Utilis pour trouver un codeop sans particularit */
extern int Opcode(char *Instruction, char *Adressage, int *CodeHexa);

/* Utilis pour analyser les modes index: En particulier identifie le reg. d'index */
extern int OpcodeINDEX(char *Instruction,char *Adressage, char *RegIndex, int *CodeHexa);

/* Utilis pour des codages spciaux d'opcode sur mode Bits (ex: 6805) */
extern int OpcodeBITs(char *Instruction,int Operande, char *Adressage, int *CodeHexa);


/*
  ----------------------- Primitives de production ------------------------
*/

extern int Coder1(char *texte,int CodeHexa);
extern int Coder2(char *texte,int CodeHexa,int operande);
extern int Coder3(char *texte,int CodeMachine,int op1,int op2);
extern int Coder4(char *texte,int CodeMachine,int op1,int op2, int op3);

extern int CoderString(char *string, int cstring);

#endif
